#define _USE_MATH_DEFINES

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,bmi,fma")

using namespace std;

#define endl "\n";

template<typename T>
istream& operator>>(istream& in, vector<T>& arr_) {
    for (auto& i_ : arr_) {
        in >> i_;
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T>& arr_) {
    for (auto& i_ : arr_) {
        out << i_ << " ";
    }
    return out;
}


using ll = long long;
using ull = unsigned long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using str = string;

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0)
#define p_b push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define int ll


ll n;

bool check(ll x, ll q, ll k) {
    ll qk = q;
    while (k != 1) {
        if (qk >= x / q) {
            return true;
        }
        qk *= q;
        k--;
    }
    return qk >= x;
}


ll get_q(int k, ll pk) {
    ll x = n / pk;
    ll l = 0, r = x;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(x, m, k)) {
            r = m;
        }
        else {
            l = m;
        }
    }
    return r;
}


vector<ll> d;
int ans = 0;

void solve(int ind, ll x) {
    if (x == n) {
        ans++;
        return;
    }
    for (int i = ind; i < (int)d.size(); i++) {
        if (n / d[i] < x) {
            break;
        }
        solve(i, x * d[i]);
    }
}


signed main() {
    fast;

    cin >> n;

    ll p;
    int k = -1;
    for (p = 2; p < 32000; p++) {
        if (n % p == 0) {
            k = 0;
            ll x = n;
            while (x % p == 0) {
                k++;
                x /= p;
            }
            break;
        }
    }
    if (k == -1) {
        cout << 1;
        exit(0);
    }

    vector<int> ans_ = { 1, 8, 30, 108, 338, 1042, 2997, 8405, 22651, 59520, 151957, 379692, 927621, 2224234, 5236585 };

    if (k <= 15) {
        cout << ans_[k - 1] << endl;
        exit(0);
    }

    vector<ll> pow_p(k + 1);
    pow_p[0] = 1;
    for (int i = 1; i <= k; i++) {
        pow_p[i] = pow_p[i - 1] * p;
    }

    ll pk = pow_p[k];
    ll q = get_q(k, pk);

    vector<ll> pow_q(k + 1);
    pow_q[0] = 1;
    for (int i = 1; i <= k; i++) {
        pow_q[i] = pow_q[i - 1] * q;
    }

    for (int i = 0; i <= k; i++) {
        for (int j = 0; j <= k; j++) {
            if (i == 0 && j == 0) {
                continue;
            }
            d.p_b(pow_p[i] * pow_q[j]);
        }
    }

    sort(all(d));

    for (int i = 0; i < (int)d.size() - 1; i++) {
        solve(i, d[i]);
    }

    cout << ans;
}