
#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <string>

typedef long long LL;

std::set<std::string> OutStrs;
std::set<int> SimpleNums = {0, 1, 2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67};

bool IsSimple( int A )
{
  return SimpleNums.find(A) != SimpleNums.end();
}

void StoreA( const std::vector<int> &A )
{
  if (A.size() < 1)
    return;

  std::string NewStr = std::to_string(A[0]);

  for (int i = 1; i < (int)A.size(); i++)
    NewStr += "+" + std::to_string(A[i]);

  OutStrs.emplace(NewStr);
}

void WorkRec( const std::vector<int> &A, int HasSimple ) // Provided 'A' has only simple numbers
{
  if (!HasSimple)
    StoreA(A);

  if (A.size() <= 2)
    return;

  int Max = A.back();

  bool ExitFlag = false;

  for (int i = 0; i < (int)A.size() - 2 && !ExitFlag; i++)
  {
    std::vector<int> NewA(A.begin(), A.begin() + i);

    int NewValue = A[i + 1] + A[i];

    
    NewA.push_back(NewValue);


    for (auto it = A.begin() + i + 2; it != A.end(); ++it) // Kal
      NewA.push_back(*it);

    if (NewValue > NewA.back())
    {
      ExitFlag = true;
      continue;
    }

    WorkRec(NewA, IsSimple(NewValue));
  }

  std::vector<int> NewA(A.begin(), A.end() - 2);
  int NewV = *(A.end() - 2) + *(A.end() - 1);

  NewA.push_back(NewV);

  WorkRec(NewA, IsSimple(NewV)); // Last pair
}

int main( void )
{
  int n;

  std::cin >> n;

  std::vector<int> Ns(n);

  for (int i = 0; i < n; i++)
    Ns[i] = 1;

  WorkRec(Ns, 0);

  for (const std::string &Str : OutStrs)
    std::cout << Str << "\n";

  return 0;
}

