def is_prime(num):
    if num < 2:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
    return True


def non_prime_partitions(n, max_num):
    def partitions(n, max_num):
        if n == 0:
            return [[]]
        result = []
        for i in range(1, min(max_num, n) + 1):
            for p in partitions(n - i, i):
                result.append([i] + p)
        return result

    partitions_list = partitions(n, n)
    non_prime_partitions = []
    for partition in partitions_list:
        if all(not is_prime(num) for num in partition):
            non_prime_partitions.append("+".join(map(str, partition)))
    return non_prime_partitions


n = int(input("Введите число n: "))
if 1 <= n <= 70:
    result = non_prime_partitions(n, n)
    for partition in result:
        print(partition)
else:
    print("Число n должно быть от 1 до 70")
