def is_prime(num):
    if num <= 1:
        return False
    for i in range(2, int(num ** 0.5) + 1):
        if num % i == 0:
            return False
    return True


def partition(n, max_val):
    if n == 0:
        return [[]]
    elif n < 0 or max_val < 1:
        return []

    partitions = []
    for i in range(1, max_val + 1):
        if not is_prime(i):
            sub_partitions = partition(n - i, min(n - i, i))
            for sub_partition in sub_partitions:
                partitions.append([i] + sub_partition)

    return partitions


n = int(input())
partitions = partition(n, n)
for partition in partitions:
    print("+".join(str(x) for x in partition))