from itertools import combinations_with_replacement
import math


def is_prime(num: int):
    if num == 1:
        return False
    
    for i in range(2, math.isqrt(num)+1):
        if num % i == 0:
            return False
        
    return True


class Solution:
    def __init__(self, num):
        self.num = num
        
    def create_non_primes_until_given_num(self) -> list[int]:
        return [i for i in range(1, self.num+1) if not is_prime(i)]

    def all_valid_combinations(self):
        non_primes = self.create_non_primes_until_given_num()

        result = {(1,) * self.num}
        for i in combinations_with_replacement(non_primes, r=self.num):
            for j, v in enumerate(i):
                if sum(i[:j]) == self.num:
                    result.add(i[:j])

        return [i for i in result if len(i) > 1]


def main():
    n = int(input())
    
    solution = Solution(n)
    for i in solution.all_valid_combinations():
        print('+'.join(str(j) for j in i))


if __name__ == "__main__":
    main()
