def get_partitions(n, start=1):
    if n == 0:
        return [[]]
    partitions = []
    for i in range(start, n + 1):
        sub_partitions = get_partitions(n - i, i)
        for sub_partition in sub_partitions:
            partitions.append([i] + sub_partition)
    return partitions

def has_prime(number):
    if number < 2:
        return False
    for i in range(2, int(number**0.5) + 1):
        if number % i == 0:
            return True
    return False

def filter_nonprime_partitions(partitions):
    return [partition for partition in partitions if not any(has_prime(num) for num in partition)]

def filter_nonincreasing(partitions):
    return [partition for partition in partitions if partition == sorted(partition)]

def print_partitions(partitions):
    for partition in partitions:
        print(' + '.join(map(str, partition)))

n = int(input())
partitions = get_partitions(n)
nonprime_partitions = filter_nonprime_partitions(partitions)
nonincreasing_partitions = filter_nonincreasing(nonprime_partitions)

print(f"Непростые разбиения числа {n} на слагаемые без простых чисел, упорядоченные по неубыванию:")
print_partitions(nonincreasing_partitions)
