def is_prime(number):
    if number <= 1:
        return False
    for i in range(2, int(number ** 0.5) + 1):
        if number % i == 0:
            return False
    return True


def non_prime_partitions(number, min_element=1):
    if number == 0:
        return [[]]
    parts = []
    for i in range(min_element, number + 1):
        if not is_prime(i):
            for sub_partition in non_prime_partitions(number - i, i):
                parts.append([i] + sub_partition)
    return parts


def format_partitions(parts):
    return ['+'.join(map(str, partition)) for partition in parts]


n = int(input())
partitions = non_prime_partitions(n)
formatted_partitions = format_partitions(partitions)
print("\n".join(formatted_partitions))
