﻿#include <iostream>
#include <vector>

void printInterestingPartitions(int n, int start, std::vector<int>& currentPartition) {
    if (n == 0) {
        // Print the current partition
        std::cout << n << "=";
        for (size_t i = 0; i < currentPartition.size(); ++i) {
            std::cout << currentPartition[i];
            if (i + 1 < currentPartition.size()) {
                std::cout << "+";
            }
        }
        std::cout << std::endl;
        return;
    }

    for (int i = start; i <= n; ++i) {
        // Check if the current number and the previous number differ by more than 1
        if (currentPartition.empty() || std::abs(i - currentPartition.back()) > 1) {
            currentPartition.push_back(i);
            printInterestingPartitions(n - i, i + 1, currentPartition);
            currentPartition.pop_back();
        }
    }
}

int main() {
    int n;
    std::cin >> n;

    std::vector<int> currentPartition;
    printInterestingPartitions(n, 1, currentPartition);

    return 0;
}